package org.prss.contentdepot.cdedge.util;

import com.sun.jna.Native;
import com.sun.jna.platform.linux.LibC;

/**
 * C library functions.
 *
 * @author mpilone
 * @since 10/3/24.
 */
public interface Pi4JLibC extends LibC {

    Pi4JLibC INSTANCE = Pi4JLibC.LibLoader.load();

    class LibLoader {
        static Pi4JLibC load() {
            return Native.load("c", Pi4JLibC.class);
        }
    }

    ///////////////////////////////////
    // fcntl.h
    int O_WRONLY = 00000001;
    int O_RDWR = 00000002;
    int O_NONBLOCK = 00004000;

    ///////////////////////////////////
    // ioctl.h
    final static int _IOC_NRBITS = 8;
    final static int _IOC_TYPEBITS = 8;
    final static int _IOC_SIZEBITS = 14;

    final static int _IOC_NRSHIFT = 0;
    final static int _IOC_TYPESHIFT = (_IOC_NRSHIFT + _IOC_NRBITS);
    final static int _IOC_SIZESHIFT = (_IOC_TYPESHIFT + _IOC_TYPEBITS);
    final static int _IOC_DIRSHIFT = (_IOC_SIZESHIFT + _IOC_SIZEBITS);

    final static byte _IOC_NONE = 0;
    final static byte _IOC_WRITE = 1;
    final static byte _IOC_READ = 2;

    static int _IOC(byte dir, byte type, byte nr, int size) {
        return (((dir) << _IOC_DIRSHIFT) |
                ((type) << _IOC_TYPESHIFT) |
                ((nr) << _IOC_NRSHIFT) |
                ((size) << _IOC_SIZESHIFT));
    }

    int ioctl(int filedes, long op, Object... args);

    int open(String pathname, int flags);

    int close(int fd);
}
